﻿package _examples_.sandy {
	import flash.events.MouseEvent;
	
	/** **********************************************************
	 * BASIC EVENTS CLASS
	 * 
	 * !!! NOTE !!!
	 * THIS EVENTS WORKS ONLY IF RENDERING LOOP IS ON.
	 * IN ANIMATOR CLASS LOOK FOR "b._scene.render();" IF IT IS COMENTED,
	 * EVENTS WILL STOP TO WORK.
	 * 
	 * @author Stanislav Zorjan - stanislav.zorjan@symblaze.com
	 */
	public class BasicEvents extends BasicLight{
		
		public function BasicEvents() {
			//this._rotateSphere = false;
			
			this._sphere.enableInteractivity = true;
			this._sphere.enableEvents = true;
			
			/* if material is wireframe, event will work only on when clicked on wire */
			this._sphere.addEventListener(MouseEvent.CLICK, sphereClick);
			
			/* first poligon with material */
			this._sphere.aPolygons[4256].addEventListener(MouseEvent.CLICK, poligonClick);
		}
		
		/** **********************************************************
		 * Method invoked when clicking on sphere object
		 * @param	e
		 */
		private function sphereClick(e:*):void {
			try{
				trace("Sphere event (polygon): " + e.polygon.id);
				trace("Sphere event (point x): " + e.point.x + ", (point y): " + e.point.y + ", (point z): " + e.point.z);
			}catch(e:Error){}
		}
		
		/** **********************************************************
		 * Method invoked when clicking on sphere face
		 * @param	e
		 */
		private function poligonClick(e:*):void {
			trace("Polygon event (polygon): " + e.target.target.id);
			trace("Polygon event (point x): " + e.point.x + ", (point y): " + e.point.y + ", (point z): " + e.point.z);
		}
	}
	
}