package previewLoader {
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.net.URLRequest;
	
	/** ***************************************************
	 * PREVIEW LOADER MAIN CLASS
	 * @author Stanislav Zorjan - zstasa@yahoo.com
	 */
	public class PreviewLoader extends Sprite {
		
		private var _loader:Loader = new Loader();
		private var _loaded:Boolean = false;
		private var _blur:BlurFilter = new BlurFilter(5, 5, 5);
		private var _swf:*;
		
		
		/** ***************************************************
		 * Simple constructor
		 */
		public function PreviewLoader():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		/** ***************************************************
		 * Initialisation method
		 * @param	e
		 */
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			stage.addEventListener(MouseEvent.MOUSE_OVER, over);
			stage.addEventListener(MouseEvent.MOUSE_OUT, out);
			
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, complete);
			_loader.load(new URLRequest(this.loaderInfo.parameters.movie));
			//_loader.load(new URLRequest("swf/away/07.swf"));
			
			var cl:uint = this.loaderInfo.parameters.color ?this.loaderInfo.parameters.color : null;
			var al:Number = this.loaderInfo.parameters.alpha ? this.loaderInfo.parameters.alpha : null;
			
			addChild(new Rect(cl, al)); 
			
			addChild(_loader);
			
		}
		
		/** ***************************************************
		 * Method invoked on stage mouse over event
		 * @param	e
		 */
		private function over(e:MouseEvent):void {
			if (_loaded) {
				_swf.over();
				this.filters = [];
			}
		} 
		
		/** ***************************************************
		 * Method invoked on stage mouse out event
		 * @param	e
		 */
		private function out(e:MouseEvent):void {
			if (_loaded) {
				_swf.out();
				this.filters = [_blur];
			}
		}
		
		/** ***************************************************
		 * Method invoked when loading swf is fully loaded
		 * @param	e
		 */
		private function complete(e:Event):void {
			//_swf = LoaderInfo(e.target).content;
			_swf = _loader.content;
			_loaded = true;
			out(null);
		}
		
	}
	
}